Debian Bug report logs - #401317
release-notes: Chapt 4. use of aptitude etc. for upgrade

version graph

Package: release-notes; Maintainer for release-notes is Debian Documentation Team <debian-doc@lists.debian.org>;

Reported by: Osamu Aoki <osamu@debian.org>

Date: Sat, 2 Dec 2006 14:33:13 UTC

Severity: normal

Tags: patch

Found in version etch-cvs-20061201

Done: Steve Langasek <vorlon@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Osamu Aoki <osamu@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Osamu Aoki <osamu@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: release-notes: Chapt 4. use of aptitude etc. for upgrade
Date: Sat, 2 Dec 2006 23:25:12 +0900
[Message part 1 (text/plain, inline)]
Package: release-notes
Version: etch-cvs-20061201
Severity: normal
Tags: patch

I understand "Chapter 4 - Upgrades from previous releases" gives generic
description for upgrade and it has been recommending to use aptitude.

But its contents looks still just as the result of  s/apt-get/aptitude/
and s/apt-cache/aptitude/ .

Considering aptitude's cli was a new additional feature and aptitude
comes with very solid visual mode, we should use it.  It also had great
enhancement for etch.

The most of the required package management activity can be done just
with aptitude (no special purpose packages such as dpig, waijig, etc.) .

Also why we mention just -f option for using aptitude.  Once after we do
partial upgrade of aptitude, we have access to new "Resolver" feature.

In light of above thoughts, I provide attached patch.  I will appreciate
if someone polish my English and include some of the valid contents to
release-notes :-)  (Oh, I bet there are some spell and grammar issues.)


REFERENCE DATA:

  # aptitude -y -s -f --without-recommends install aptitude
...
8 packages upgraded, 17 newly installed, 0 to remove and 118 not upgraded.
Need to get 0B/11.9MB of archives. After unpacking 19.6MB will be used.

This is for the mini upgrade.  20 MB is not much.  So partial upgrade
should not be too much of system trouble.  libc is upgraded in this
process.
-- 
~\^o^/~~~ ~\^.^/~~~ ~\^*^/~~~ ~\^_^/~~~ ~\^+^/~~~ ~\^:^/~~~ ~\^v^/~~~ +++++
        Osamu Aoki <osamu@debian.org>  Yokohama Japan, GPG-key: A8061F32
 .''`.  Debian Reference: post-installation user's guide for non-developers
 : :' : http://qref.sf.net and http://people.debian.org/~osamu
 `. `'  "Our Priorities are Our Users and Free Software" --- Social Contract

[diff.txt (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Frans Pop <elendil@planet.nl>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 401317@bugs.debian.org (full text, mbox):

From: Frans Pop <elendil@planet.nl>
To: Osamu Aoki <osamu@debian.org>, 401317@bugs.debian.org
Subject: Re: Bug#401317: release-notes: Chapt 4. use of aptitude etc. for upgrade
Date: Sat, 02 Dec 2006 23:12:46 +0100
[Message part 1 (text/plain, inline)]
On Saturday 02 December 2006 15:25, Osamu Aoki wrote:
> REFERENCE DATA:
>   # aptitude -y -s -f --without-recommends install aptitude
> ...
> 8 packages upgraded, 17 newly installed, 0 to remove and 118 not
> upgraded. Need to get 0B/11.9MB of archives. After unpacking 19.6MB
> will be used.
>
> This is for the mini upgrade.  20 MB is not much.  So partial upgrade
> should not be too much of system trouble.  libc is upgraded in this
> process.

It looks like you tried that on a fairly minimal system.
For my "upgrade test system", which has the Sarge Desktop task installed 
(i.e. Gnome and KDM desktops), I get 197 packages to remove with that 
command, including most of Gnome and the 2.4 kernel (without 
replacement)...

43 packages upgraded, 41 newly installed, 197 to remove and 554 not
upgraded. Need to get 50.9MB of archives. After unpacking 428MB
will be freed.

So far the only working method I've been able to find to upgrade that is 
to use aptitude interactively (i.e. the frontend, not from the 
commandline).

Cheers,
FJP
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Osamu Aoki <osamu@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 401317@bugs.debian.org (full text, mbox):

From: Osamu Aoki <osamu@debian.org>
To: Frans Pop <elendil@planet.nl>
Cc: 401317@bugs.debian.org
Subject: Re: Bug#401317: release-notes: Chapt 4. use of aptitude etc. for upgrade
Date: Sun, 3 Dec 2006 20:41:47 +0900
Hi,

Let me do experiment and thinking.

On Sat, Dec 02, 2006 at 11:12:46PM +0100, Frans Pop wrote:
> On Saturday 02 December 2006 15:25, Osamu Aoki wrote:
> > REFERENCE DATA:
> >   # aptitude -y -s -f --without-recommends install aptitude
                            ^^^^^^^^^^^^^^^^^^^^^^^^^^
This is not "--with-recommends upgrade" nor "--with-recommends dist-upgrade".

This was meant to upgrade only aptitude and its depending libraries such
as libc after pointing /e/a/sources.list to etch.

> > ...
> > 8 packages upgraded, 17 newly installed, 0 to remove and 118 not
> > upgraded. Need to get 0B/11.9MB of archives. After unpacking 19.6MB
> > will be used.
> >
> > This is for the mini upgrade.  20 MB is not much.  So partial upgrade
> > should not be too much of system trouble.  libc is upgraded in this
> > process.
> 
> It looks like you tried that on a fairly minimal system.

Yes.  But ...

What is wrong with upgrade under a fairly minimal system :-)

This is my kind of conclusion after trying to upgrade desktop system
chroot as below.

> For my "upgrade test system", which has the Sarge Desktop task installed 
> (i.e. Gnome and KDM desktops), I get 197 packages to remove with that 
> command, including most of Gnome and the 2.4 kernel (without 
> replacement)...
> 
> 43 packages upgraded, 41 newly installed, 197 to remove and 554 not
> upgraded. Need to get 50.9MB of archives. After unpacking 428MB
> will be freed.
> 
> So far the only working method I've been able to find to upgrade that is 
> to use aptitude interactively (i.e. the frontend, not from the 
> commandline).

I see your point if upgrade is done with these big Gnome/KDE things.
Interactive dependency resolution is much better with etch version.  So
if I have to do it, I would rather use etch version of aptitude.

Basically I thought required steps should be as follows.

Step 1. Kernel upgrade in sarge (2.2, 2.4 --> 2.6 with udev)
Step 2. Point /e/a/sources.list to etch (include nonfree contrib
        if GFDL doc packages and others are needed.)
Step 3. Partial upgrade to etch (aptitude and its deps.)
  # aptitude --without-recommends install aptitude
Step 4. Full conservative upgrade to etch using etch aptitude.
  # aptitude --without-recommends upgrade
  ... press "e" to do interactive
Step 5. Full complete upgrade to etch using etch aptitude.
  # aptitude --with-recommends dist-upgrade
  ... press "e" to do interactive

Let me test this in sarge chroot (except step 1) using "pbuilder login
--basetgz sarge".

I installed all desktop, mail server, print server, and file server
tasks using sarge aptitude (plus "screen", "mc")  to this chroot
environment to simulate you.  This was big chunk of downloads since
local cache for pbuilder was empty for most sarge packages this time :-)
...
dpkg: dependency problems prevent configuration of kdessh:
 kdessh depends on ssh; however:
  Package ssh is not configured yet.
dpkg: error processing kdessh (--configure):
 dependency problems - leaving unconfigured
...
Errors were encountered while processing:
 ssh
 uw-imapd
 kdessh
 kdeutils
 kde
Oh, well.  It is chroot.  Let's move on.

I wanted to run aptitude in "screen" session on pbuilder login shell
which is in gnome-terminal(parent) from here on.  Oops, screen does not
work in chroot.  OK, let's move on.

For Step 2, I did not includ nonfree and contrib just to make situation
worse. So just s/sarge/etch/ .

For step 3:
root@dambo:/# aptitude update; aptitude --without-recommends install aptitude
...
46 packages upgraded, 46 newly installed, 423 to remove and 534 not upgraded.
Need to get 11.6MB/50.2MB of archives. After unpacking 773MB will be freed.
Do you want to continue? [Y/n/?] y
...

This is almost same situation as you said.  I intensionally did "Y" here
to simulate your experience further.

As I look into new aptitude interactively, I see no desktop task.  Now
we have obscurely located gnome-desktop and kde-desktop.  No wonder it
was removing so much.  I set "gnome-desktop" and "kde-desktop" tasks to
be installed by pressing with "+" over them.  (Next time, I should set
all task selected packages not as "A" by pressing "m" in sarge.)  Now I
have RED resolver prompt screen.  Let me press "e" for examine.

Looks like it removes xlibs... Oh, well bang "!" and "g" to move on.  It
installs many packages.  I guess next round of action is to use "U" or
issue dist-upgrade and done.  Well let me try again with cooler head.

********************************************************************

With big changes between old stable to new stable, things like GCC ABI
changes etc. will happen.  Under this condition, even if we try to do
just partial upgrade of aptitude in full system, this upgrade will pull
in libc6 and all other C++ libraries.  Then these libraries have
"conflict" set with older packages.  Then they get upgraded unless we
allow them to be broken relationship.  That is not so easy with sarge
aptitude.

********************************************************************
So what is the better option.  KISS!

Any desktop system packages are going to be upgraded.  Why have them!

As long as we do not purge those packages, we are suppose to keep
package configutration.  Unlike our normal daily/weekly sid upgrades,
the old stable to new stable transition may be better done under fairly
minimal services.

Step 1. Kernel upgrade in sarge (2.2, 2.4 --> 2.6 with udev)
Step 2. Remove all Desktop Environment in Tasksel placing "-" over it
        and do "g".  This removes many files but at least you know what
        have been removed. You never need these while upgrading.
        (Actually cyclic dependency keeps some packages)
Step 3. Point /e/a/sources.list to etch (include nonfree contrib
        if GFDL doc packages and others are needed.)
        and do "aptitide update". (Do not worry about warning)
Step 4. Partial upgrade to etch (aptitude, tasksel and its deps.)
  # aptitude install aptitude tasksel
  (See below.  It is decent situation "13 packages upgraded, 12 newly
  installed, 1 to remove and 321 not upgraded." is manageable things.)
Step 5. Start new aptitude and set Desktop thingy.
  # aptitude
  ... press "+" over "End-user" in "Tasks".  So we get new full
      etch desktop. 
  ... press "U" to upgrade all and try resolving with "e" and "!" "g"
  ... press "Y" for `/etc/dpkg/dpkg.cfg'
  ... After everythng, do it again. press "+" over "End-user". 
  ... No problem (no red resolver).  "g"
  ... Hmmm... Let's remove Obsolete interactively.  "g".

This was much saner upgrade than upgrade with Desktop.  

I guess going down dependency chain from DEsktop Task may be needed if
some packages were not marked as automatic.  I do not know if I should
force to mark "libs" etc.  Probaable yes.

Anyway, I hope this helps.

--- HERE is log ----
root@dambo:/# aptitude install aptitude tasksel
...
Reading task descriptions... Done
The following NEW packages will be automatically installed:
  debian-archive-keyring dmidecode gcc-4.1-base gnupg gpgv laptop-detect
  libdb4.4 libsigc++-2.0-0c2a libusb-0.1-4 readline-common tasksel-data
  tzdata
The following packages will be automatically REMOVED:
  base-config
The following packages have been kept back:
  ...
The following NEW packages will be installed:
  debian-archive-keyring dmidecode gcc-4.1-base gnupg gpgv laptop-detect
  libdb4.4 libsigc++-2.0-0c2a libusb-0.1-4 readline-common tasksel-data
  tzdata
The following packages will be REMOVED:
  base-config
The following packages will be upgraded:
  apt apt-utils aptitude debconf libc6 libc6-dev libgcc1 libncurses5
  libncursesw5 libreadline5 libstdc++6 locales tasksel
The following packages are RECOMMENDED but will NOT be installed:
  aptitude-doc-en
13 packages upgraded, 12 newly installed, 1 to remove and 321 not upgraded.
Need to get 4447kB/20.5MB of archives. After unpacking 12.7MB will be used.
Do you want to continue? [Y/n/?]
--------------------

In conclusion, concept should be:
 * remove (not purge) all Desktop packaes.
 * upgrade aptitude and tasksel first.
 * Then go all the way.

I hope this helps to shape Release note.

Osamu










Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Osamu Aoki <osamu@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 401317@bugs.debian.org (full text, mbox):

From: Osamu Aoki <osamu@debian.org>
To: Frans Pop <elendil@planet.nl>
Cc: 401317@bugs.debian.org
Subject: Re: Bug#401317: release-notes: Chapt 4. upgrade :dselect
Date: Tue, 5 Dec 2006 00:35:03 +0900
Hi,

Tonight I did upgrade with good old "dselect" (via APT).  It is working
good.  I was presented with 2 conflicts (pronter things) and removing
offending package was all it needed. (chroot test)

No steps but just one step.

So far it looks like upgrading nicely.

Osamu




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Osamu Aoki <osamu@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 401317@bugs.debian.org (full text, mbox):

From: Osamu Aoki <osamu@debian.org>
To: Frans Pop <elendil@planet.nl>
Cc: 401317@bugs.debian.org
Subject: Re: Bug#401317: release-notes: upgrade: dselect
Date: Tue, 5 Dec 2006 00:55:27 +0900
Hmmm... dselect with "U" was not so interesting for upgrades.  It just
did minimal upgrades and kept many packages.  This is probably because
there were upgrade errors.  Oh well.  Upgrade of full install desktop
system is difficult with dselect.

Osamu



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to "Jonathan Quick" <jon@hartrao.ac.za>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 401317@bugs.debian.org (full text, mbox):

From: "Jonathan Quick" <jon@hartrao.ac.za>
To: "Frans Pop" <elendil@planet.nl>
Cc: 401317@bugs.debian.org
Subject: Aptitude quite happily "upgrades" aptitude from sarge->etch
Date: Wed, 6 Dec 2006 15:07:38 +0200 (SAST)
Hi Frans

In testing out upgrade of a fresh sarge installation which included the
desktop task ie. both Gnome and KDE, in desperation I found that (after
updating sources.list to point to etch and 'apt-get update') the
command

      aptitude upgrade aptitude

gives

Reading Package Lists... Done
Building Dependency Tree... Done
The following packages have been kept back:
 ...
The following packages will be upgraded:
  base-files console-common console-data debconf debconf-i18n defoma
  desktop-base dictionaries-common discover1-data doc-debian doc-linux-text
  docbook-dsssl docbook-xml dosfstools edict esound-common fortunes-min
  gcc-3.4-base gnome-desktop-data gnome-icon-theme gnome-mime-data gnu-efi gs
  gs-common gsfonts gtk2-engines-spherecrystal hicolor-icon-theme hotplug
  iamerican ibritish imlib-base initrd-tools kanjidic kdeartwork-misc
  kdeartwork-theme-icon kdeedu-data kdegames-card-data
  kdemultimedia-kappfinder-data kdewallpapers knewsticker-scripts
libeel2-data
  libevent1 libfinance-quote-perl libgda2-common libgnomeprintui2.2-common
  libgtk1.2-common libgtk2.0-common libgtksourceview-common
  libhtml-tableextract-perl libhtml-tagset-perl libhtml-tree-perl libmad0
  libmailtools-perl libmime-perl libnews-nntpclient-perl libpam-runtime
  libpango1.0-common libsnmp-base libss2 libtext-wrapi18n-perl
  libtimedate-perl liburi-perl libwnck-common libwww-perl
linux-kernel-headers
  lsb-base mailx makedev manpages manpages-dev menu-xdg mime-support
  myspell-en-gb myspell-en-us ncurses-term net-tools pppconfig sharutils
  sysv-rc ttf-bitstream-vera ttf-opensymbol wamerican xml-core
83 upgraded, 0 newly installed, 0 to remove and 662 not upgraded.
Need to get 58.5MB of archives. After unpacking 11.9MB will be used.
Do you want to continue? [Y/n/?]

and quite happily installs the 'etch' version of aptitude.  I suspect this
trick will work no matter what other Debian packages one has installed.

After that I found I had to run

  aptitude install libfam0

and

  aptitude install libglu1-mesa

to break two conflict loops and thereafter

  aptitude -f --with-recommends dist-upgrade

proceeds quite happily.  It says thet 0 packages will not be upgraded -
but I won't know how well it works till it completes.

Regards
  Jon




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Osamu Aoki <osamu@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #35 received at 401317@bugs.debian.org (full text, mbox):

From: Osamu Aoki <osamu@debian.org>
To: Frans Pop <elendil@planet.nl>, 401317@bugs.debian.org
Subject: Re: Bug#401317: release-notes: Chapt 4. use of aptitude etc. for upgrade
Date: Wed, 6 Dec 2006 23:53:56 +0900
On Sat, Dec 02, 2006 at 11:12:46PM +0100, Frans Pop wrote:
> On Saturday 02 December 2006 15:25, Osamu Aoki wrote:
> So far the only working method I've been able to find to upgrade that is 
> to use aptitude interactively (i.e. the frontend, not from the 
> commandline).

I tried 
vim /e/a/sorces.list
apt-get update; apt-get install aptitude tasksel; aptitude

This was most same process so far.

This allows me to use etch aptitude and tasksel was sane.  Sp I could
select all needed tasks and upgrade with minimal manual work.  I will
try more for best method.  (Trying aptitude dist-upgrade now).

Osamu




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Osamu Aoki <osamu@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #40 received at 401317@bugs.debian.org (full text, mbox):

From: Osamu Aoki <osamu@debian.org>
To: Jonathan Quick <jon@hartrao.ac.za>, 401317@bugs.debian.org
Cc: Frans Pop <elendil@planet.nl>
Subject: Re: Bug#401317: Aptitude quite happily "upgrades" aptitude from sarge->etch
Date: Thu, 7 Dec 2006 00:01:26 +0900
On Wed, Dec 06, 2006 at 03:07:38PM +0200, Jonathan Quick wrote:
> Hi Frans
> 
> In testing out upgrade of a fresh sarge installation which included the
> desktop task ie. both Gnome and KDE, in desperation I found that (after
> updating sources.list to point to etch and 'apt-get update') the
> command
> 
>       aptitude upgrade aptitude

 aptitude upgrade does not take any more command line parameters.

If you are thinking to upgrade aptitude
 aptitude install aptitude

or since you need new tasksel too
 aptitude install aptitude tasksel

That is a start for sure.  But question still remain how best follow
this if we were to present best known method for (dist-)upgrade.

See more on Bug#401317.

Osamu



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Osamu Aoki <osamu@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #45 received at 401317@bugs.debian.org (full text, mbox):

From: Osamu Aoki <osamu@debian.org>
To: 401317@bugs.debian.org
Cc: Frans Pop <elendil@planet.nl>
Subject: Re: Bug#401317: release-notes: Chapt 4. use of aptitude etc. for upgrade
Date: Fri, 8 Dec 2006 01:30:42 +0900
On Wed, Dec 06, 2006 at 11:53:56PM +0900, Osamu Aoki wrote:
> On Sat, Dec 02, 2006 at 11:12:46PM +0100, Frans Pop wrote:
> > On Saturday 02 December 2006 15:25, Osamu Aoki wrote:
> > So far the only working method I've been able to find to upgrade that is 
> > to use aptitude interactively (i.e. the frontend, not from the 
> > commandline).
> 
> I tried 
> vim /e/a/sorces.list
> apt-get update; apt-get install aptitude tasksel; aptitude


vim /e/a/sorces.list
apt-get -y update; apt-get -y install aptitude tasksel; aptitude -y dist-upgrade

then aptitude and place + on desktop and g 
then again aptitude and place + on desktop and g

Then I seen to have decent upgrade

Thisa is simpliest I have done.

Osamu



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Osamu Aoki <osamu@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #50 received at 401317@bugs.debian.org (full text, mbox):

From: Osamu Aoki <osamu@debian.org>
To: 401317@bugs.debian.org
Cc: Frans Pop <elendil@planet.nl>
Subject: Re: Bug#401317: release-notes: Chapt 4. use of aptitude etc. for upgrade
Date: Sun, 10 Dec 2006 10:34:34 +0900
Hi,

Below is the review of mass upgrade experiment as previously done.

Then I found 
 http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=391377

Even new aptitude has issue with Conflicts/Replaces/Provides.

If we were to do manual work, why not making process simple by trimming
system first in known ways.  So if something happens, it is manageable.

So I think correct thing to do is trim system first as reported. So Let
me update it with minor comments for apt-get.

Step 1. Kernel upgrade in sarge (2.2, 2.4 --> 2.6 with udev)
Step 2. Remove all Desktop Environment in Tasksel placing "-" over it
        and do "g".  This removes many files but at least you know what
        have been removed. You never need these while upgrading.
        (Actually cyclic dependency keeps some packages)
Step 3. Point /e/a/sources.list to etch (include nonfree contrib
        if GFDL doc packages and others are needed.)
        and do "aptitide update". (Do not worry about warning)
Step 4. Partial upgrade to etch (aptitude, tasksel and its deps.)
  # aptitude install aptitude tasksel
  (See below.  It is decent situation "13 packages upgraded, 12 newly
  installed, 1 to remove and 321 not upgraded." is manageable things.)
  (If one has been not using aptitude, apt-get may be better idea in 
   the above)
Step 5. Start new aptitude and set Desktop thingy.
  # aptitude
  ... press "+" over "End-user" in "Tasks".  So we get new full
      etch desktop.
  ... press "U" to upgrade all and try resolving with "e" and "!" "g"
  ... press "Y" for `/etc/dpkg/dpkg.cfg'
  ... After everythng, do it again. press "+" over "End-user".
  ... No problem (no red resolver).  "g"
  ... Hmmm... Let's remove Obsolete interactively.  "g".

(If one has been using apt-get, use of keep-all for aptitude may be an idea)

This was much saner upgrade than upgrade with Desktop.

**** See below for the mass upgrade. ******

On Fri, Dec 08, 2006 at 01:30:42AM +0900, Osamu Aoki wrote:
> On Wed, Dec 06, 2006 at 11:53:56PM +0900, Osamu Aoki wrote:
> > On Sat, Dec 02, 2006 at 11:12:46PM +0100, Frans Pop wrote:
> > > On Saturday 02 December 2006 15:25, Osamu Aoki wrote:
> > > So far the only working method I've been able to find to upgrade that is 
> > > to use aptitude interactively (i.e. the frontend, not from the 
> > > commandline).
> > 
> > I tried 
> > vim /e/a/sorces.list
> > apt-get update; apt-get install aptitude tasksel; aptitude
> 
> 
> vim /e/a/sorces.list
> apt-get -y update; apt-get -y install aptitude tasksel; aptitude -y dist-upgrade
> 
> then aptitude and place + on desktop and g 
> then again aptitude and place + on desktop and g
> 
> Then I seen to have decent upgrade
> 
> This is the simpliest I have done.

Here is the raionale to use apt-get instead of aptitude in the above
example:

| root@dambo:/# apt-get install tasksel aptitude
| 69 upgraded, 50 newly installed, 91 to remove and 762 not upgraded.
                                   ^^^^^^^^^^^^
| Need to get 0B/77.1MB of archives. After unpacking 218MB disk space will be freed.
| 
| root@dambo:/# aptitude install tasksel aptitude
| 56 packages upgraded, 50 newly installed, 320 to remove and 606 not upgraded.
                                            ^^^^^^^^^^^^
| Need to get 0B/63.5MB of archives. After unpacking 546MB will be freed.
| 
| root@dambo:/# aptitude --without-recommends install tasksel aptitude
| 48 packages upgraded, 49 newly installed, 400 to remove and 544 not upgraded.
                                            ^^^^^^^^^^^^
| Need to get 0B/50.7MB of archives. After unpacking 735MB will be freed.

(This does not mean this was small enough impact to the system.)
-----

As for aptitude(etch) invoked with dist-upgrade

| The following packages will be REMOVED:
|   akode hotplug kdelibs-bin kdelibs4 libarts1 libkcal2a libkdeedu1
|   libkdepim1 libkleopatra0a libmimelib1a libmodplug0 libmusicbrainz4
|   libnewt0.51 libopenexr2 libpng10-0 libpth2 libqt3c102-mt
|   libroken16-kerberos4kth libstlport4.6 libtag1 libtidy0 libxft1
|   netkit-inetd openoffice.org-bin python2.3-glade2 python2.3-gtk2
|   python2.3-numeric xfree86-common xlibs xserver-common

openoffice.org-bin removal is something I do not want to see.

(netkit-inetd removal needs to be checked for the reason behind it but
this is OK with me.)

In etch: openoffice.org is a metapackage which installs all components
of openoffice.org and it is listed under "Tasks" -> "End-user" ->
"Desktop environment". openoffice.org-bin does not exist in etch.

Also as I opened after execution, many gnome packages are removed.
As I look back apt-get process:

| The following packages will be REMOVED:
|   abiword-common abiword-gnome abiword-help at-spi base-config bluefish
|   bug-buddy capplets dasher dia-gnome eog epiphany-browser epiphany-extensions
|   evolution file-roller foomatic-gui gcalctool gconf-editor gdm gedit gnome
|   gnome-about gnome-applets gnome-control-center gnome-core gnome-cups-manager
|   gnome-desktop-environment gnome-games gnome-gv gnome-mag gnome-media
|   gnome-nettool gnome-office gnome-panel gnome-pilot gnome-pilot-conduits
|   gnome-session gnome-system-monitor gnome-system-tools gnome-terminal
|   gnome-utils gnome-volume-manager gnomemeeting gnopernicus gnumeric gok gpdf
|   gthumb gtkhtml3.2 inkscape libatspi1.0-0 libbonoboui2-0 libeel2-2
|   libgail-common libgail-gnome-module libgail17 libgal2.2-1 libgal2.2-common
|   libglibmm-2.4-1 libgnome-desktop-2 libgnome2-canvas-perl libgnome2-perl
|   libgnomecanvas2-0 libgnomecupsui1.0-1 libgnomeprintui2.2-0 libgnomeui-0
|   libgtkhtml2-0 libgtkhtml3.2-11 libgtkmm-2.4-1 libnautilus2-2
|   libpanel-applet2-0 librsvg2-bin libsigc++-2.0-0 libvte4 nautilus
|   nautilus-cd-burner nautilus-media planner python-gnome2 python-imaging
|   python-tk python2.3-gnome2 python2.3-tk rhythmbox sketch synaptic totem
|   totem-xine vino yelp zenity

No wonder.  After playing with some upgrade (confirming apt-get install
aptitude tasksel action as what is needed to aptitude manually), I can
upgrade system in new aptitude but with all above packages removed, I
really do not see upgrading in fat system if I have to readd them
anyway.  Besides, kde and gnome desktop environment changed virtual
packages to get them all installed, missing them in upgraded system
anyway request user to go over task list.

Osamu




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Osamu Aoki <osamu@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #55 received at 401317@bugs.debian.org (full text, mbox):

From: Osamu Aoki <osamu@debian.org>
To: debian-devel@lists.debian.org
Cc: 401317@bugs.debian.org
Subject: Upgrade desktop system between stables
Date: Sun, 10 Dec 2006 15:08:57 +0900
Hi fellow developers,

I see some basic packages already frozen.  So we will release etch soon.
But (dist-)upgrade seems quite problematic.  As seen on debian-user
list, I see many people are hit with difficulty of (dist-)upgrade. 

Old_stable -> new_stable upgrade involves:
 * major library upgrades with conflict set for previous ones.
 * package reorganization with conflict set for previous ones.
    - new, split, merged, renamed and removed packages
Since all these happen simultaneously, things are much more difficult
for old_stable -> new_stable than daily sid upgrade.  It was not much
fun as I did it.  If anyone of you can suggest elegant upgrade path
which can be used for release note, please send suggestion to
401317@bugs.debian.org.  (Manual dependency resolution in multiple
aptitude runs or removal of large chunk of system in advance does not
qualify to be elegant.)

> Is installer can be improved to install new system to a chroot and allow
> switching root system upon reboot to let old system appear in such
> location as /oldsystem ?  Then can we provide tools or hooks to
> duplicate old system to new one?

This is my wishlist thought after trying to simulate upgrade of desktop
system.

For the record, I tested sarge to etch upgrades so far following
proposed release notes using pbuilder chroot:
 http://www.debian.org/releases/etch/i386/release-notes/ch-upgrading.en.html
I had to remove big chunk of system before upgrade to have reasonable
upgrade.  (In case when you need kernel/udev upgrades, it seems easier
to do fresh install for sure.)

Basically if you have installed a set of packages with complicated
dependency chains and interesting package name changes, your upgrade will
become too complicated for you to manage while aptitude keep trying to
delete large chunk of system.  Few hundred packages removed are too many
to manage. You need to install them later to recover them. I think you
will be better off doing fresh install or doing upgrade after removing
all these sets of packages in advance while your head is cool.

I am talking sets such as:
 gnome packages
 kde packages
 tetex packages

See BTS
 http://bugs.debian.org/391377
 http://bugs.debian.org/401317

Even with etch version of aptitude, Conflicts/Replaces/Provides
resolution is not yet optimal per bug 391377.  So we will hit similar
situation for etch+1.

(I have not checked issues with apache etc.)

Thanks in advance,

Osamu




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to Osamu Aoki <osamu@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #60 received at 401317@bugs.debian.org (full text, mbox):

From: Osamu Aoki <osamu@debian.org>
To: debian-release@lists.debian.org
Cc: 401317@bugs.debian.org
Subject: Re: RELEASE NOTE (suggestion)
Date: Sat, 20 Jan 2007 23:20:41 +0900
Hi,

I thought my suggestion was just a reminder to something everyone agree
once you do upgrade of desktop system onself. Hmmm... I will add this
discussion to my old report on this issue as a record.
 http://bugs.debian.org/401317
Back then Frans said he needed to use interactive session to upgrade
desktop system.

Steve, your technical assessment itself on possible concerns for pulling
tasksel is quite right as usual :) But I think I did not communicated my
concern well.

I am not quite sure how exactly current aptitude displays task list.  It
looks like aptitude uses /usr/share/tasksel/debian-tasks.desc to
establish package list which each task pulls in.

This /usr/share/tasksel/debian-tasks.desc used to be in task package but
now moved to tasksel-data package.  Somehow these 2 packages "Depends:"
on each other.  If there is no "Depends: tasksel" in tasksel-data,
installing tasksel-data is the almost no liability action to get
aptitude with correct task list. But under current situation, it pulls
in tasksel and causes concerns Steve raised.

Let me comment as follows.

On Sat, Jan 20, 2007 at 02:16:00AM -0800, Steve Langasek wrote:
> Hi Osamu,
> 
> On Mon, Jan 15, 2007 at 11:12:48PM +0900, Osamu Aoki wrote:
> > On Mon, Jan 15, 2007 at 02:42:20AM -0800, Steve Langasek wrote:
> > > On Mon, Jan 15, 2007 at 03:07:30AM +0900, Osamu Aoki wrote:
> 
> > > > In 4.4.2 Upgrading aptitude
> 
> > > > You only updating aptitude.
> 
> > > > I think updating tasksel (hence tasksel-data) together will make less
> > > > surprise.  (Proper Desktop task list ...)
> 
> > > > -     # aptitude install aptitude
> > > > +     # aptitude install aptitude tasksel
> 
> > > Why would it be important to install tasksel before dist-upgrading?  tasksel
> > > isn't called directly in the upgrade process, and I don't think aptitude
> > > dist-upgrade looks at tasks either, does it?

To get reasonably looking task list.

> > I do not think I said "important".  I just *suggested* this since I
> > thought it is a *good* idea to "make less surprise" under unpredictable
> > upgrade breakage.  I mean this is zero liability action with reduction
> > of possible negative situation.
> 
> The liability is:
> 
> - Some users will not have tasksel installed on their system.  Telling them
>   to run aptitude install aptitude tasksel will install a package that they
>   don't need or want.
> - Some users will know that they don't want tasksel installed, and ignore
>   these instructions.  That increases the number of upgrade paths that we
>   need to support.
> - tasksel has dependencies that wouldn't otherwise need to be pulled in at
>   this early stage -- in particular, a newer version of debconf than shipped
>   with sarge.  This makes the first stage of the upgrade more complex, and
>   therefore increases the risk of bugs.  We want this part of the upgrade to
>   be simple.
> - If something does go wrong, novice users will have a harder time
>   understanding what happened because of the larger number of packages
>   involved.
> 
> So yes, there needs to be an important reason that outweighs these
> liabilities. :)

Correct.  What is really needed is tasksel-data as I mentioned as above.

> > Here is a bit more explanation.  As stated in 4.4.2, "In some cases if a
> > large number of packages is listed for removal", this is what I fear.
> > Of course if your KDE fix trick closes the gap completely and "aptitude
> > -f --with-recommends dist-upgrade" nicely upgrade system without
> > interactive work, my fear may be non-significant one. 
> 
> > But an user may have installed some funny set of non-desktop programs
> > which we did not tested (tetex?) and it may create problem.  Current
> > aptitude as released for etch will have important and difficult to fix
> > bug before release for dist-upgrade.  
> 
> > See http://bugs.debian.org/391377 .  
> 
> > Whoever hits such a bug will try to resolve it relying on aptitude's
> > interactive mode to solve situation.  If we do not update tasksel-data,
> > the menu under tasks does not seem to have reasonable appearance for
> > desktop task etc.  So we can focus on addressing real issue.
> 
> So your concern is that users will try to resolve this dist-upgrade
> interactively, rather than choosing one of the solutions from the
> commandline interface, and that in the process they'll use the task list?  I
> suppose this is possible, but a) I don't see how the task list is relevant
> to resolving a dist-upgrade problem, b) using aptitude interactively is
> already not part of the documented, recommended upgrade procedure, right?

As I tested before in 401317, when complication happens with desktop
task, the easiest way for me was to remove (but not purge) all desktop
packages from the aptitude task menu and update the smaller system.
Then installed the desktop relying on the task list.  For that, I needed
tasksel-data and for me typing tasksel was the shortest name. (Due to
mutual dependency, it did not make any difference using tasksel or
tasksel-data)

Since I did not use perl upgrade trick as described, my concern may have
been just worry. I will revisit this when I find my time.

Osamu




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Documentation Team <debian-doc@lists.debian.org>:
Bug#401317; Package release-notes. Full text and rfc822 format available.

Acknowledgement sent to "Kevin B. McCarty" <kmccarty@Princeton.EDU>:
Extra info received and forwarded to list. Copy sent to Debian Documentation Team <debian-doc@lists.debian.org>. Full text and rfc822 format available.

Message #65 received at 401317@bugs.debian.org (full text, mbox):

From: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
To: 396496@bugs.debian.org, 396331@bugs.debian.org, 405165@bugs.debian.org, 401317@bugs.debian.org
Subject: Suggested upgrade path to put in Etch release notes
Date: Tue, 06 Feb 2007 17:11:05 -0800
[Message part 1 (text/plain, inline)]
Hello,

Now that the xserver-xorg package in Etch depends once again on X
modules xserver-xorg-video-all and xserver-xorg-input-all (rather than
just recommending them), the following Sarge -> Etch upgrade path seems
to work for me.  I've now tested this on two systems that each have a
fair bit of Gnome installed.

Unfortunately it seems one cannot use aptitude in a set of general
upgrade instructions, since in some cases upgrading it causes a lot of
other packages to be removed undesirably.  It would therefore be nice if
Debian could make available new versions of aptitude backported to libs
in the old stable release.

0) [edit /etc/apt/sources.list to point at Etch]
1) apt-get update
2) apt-get install initrd-tools
3) apt-get install apt
4) apt-get update
5) apt-get dist-upgrade
6) apt-get install aptitude
7) aptitude dist-upgrade
8) aptitude install <whatever got removed undesirably>
9) aptitude (run interactively and get rid of obsolete packages)
10) install new kernel package(s)

Remarks:

Step 2 works around the conflict between new libc6 and old initrd-tools.

In step 3 aptitude may end up getting removed.  Trying to "apt-get
install aptitude" at this point was easy on one of my test systems; but
on the other one, it would have resulted in much of Gnome going away for
whatever reason.

Step 4 is to obtain the Release.gpg files with the new secure APT.

Downgrading back to Sarge at any point before 5) is not too hard as long
as one removes all the new python2.4 packages and is careful about the
fact that the new tzdata package replaces numerous files in the old
libc6 package (necessitating several rounds of "dpkg --force-overwrite
--install /var/cache/apt/archives/libc6*.deb").

In step 5, capplets, gnome-volume-manager, hal, hotplug and inkscape end
up getting removed (along with an unofficial mplayer package and a large
number of obsolete compiler, interpreter, library, and libdevel
packages, about 60 total).  This is however better than what happens if
one were to try "apt-get install aptitude" at this point.  This is the
list of removed packages after "apt-get dist-upgrade" on the more
problematic of my two test machines:

> The following packages will be REMOVED
>   aspell-bin blas-dev capplets g77-3.3 gnome-volume-manager hal hotplug
>   inkscape lapack-dev libcojets1-dev libdps1 libfltk1.1c102 libgc1
>   libgeant1-dev libggi-target-x libggi2 libgii0 libgii0-target-x
>   libgksuui1.0-0 libglibmm-2.4-1 libgtkmm-2.4-1 libherwig59-dev
>   libisajet758-dev libkuipx11-1-dev libmagick++6 libmagick6 libmathlib1-dev
>   libmodplug0 libnautilus2-2 libnewt0.51 libostyle1 libpaw1-dev
>   libpdflib804-dev libphtools1-dev libpstoedit0 libqt3-dev libqt3c102-mt
>   libsigc++-2.0-0 libstlport4.6 libtiffxx0 libxft1 libxklavier8
>   mozilla-firefox-gnome-support mplayer netkit-inetd ntp-server nvidia-glx-dev
>   openoffice.org-bin openoffice.org-debian-files openoffice.org-l10n-en pm-dev
>   pstoedit python2.3 python2.3-dev python2.3-gtk2 python2.3-iconvcodec
>   python2.3-imaging python2.3-numeric python2.3-tk t1lib1 xfree86-common xlibs
>   xlibs-dev xserver-common

and this is the list of packages to be removed on the other test machine
(interesting items include abiword-gnome, grace, capplets):

> The following packages will be REMOVED:
>   abiword-doc abiword-gnome abiword-plugins blas-dev capplets g77-2.95 g77-3.3
>   grace lapack-dev libdps1 libenchant1 libgc1 libkuipx11-1-dev libmagick6
>   libmathlib1-dev libmyspell3 libnautilus2-2 libnewt0.51 libostyle1
>   libpaw1-dev libstlport4.6 libwpd8 libxft1 libxklavier8 netkit-inetd
>   openoffice.org-bin openoffice.org-debian-files openoffice.org-l10n-en
>   python2.3 xfree86-common xlibs xserver-common

If one still has aptitude, one may run "aptitude --without-recommends
dist-upgrade" for step 5 instead of "apt-get dist-upgrade".  On my test
machine where aptitude was still available at this point, "aptitude
dist-upgrade" (with recommends) never converged to a solution for the
large number of conflicts, but --without-recommends worked OK.

Step 6 is obviously only needed if aptitude was removed by step 3.

Step 7 is for picking up Recommends and/or removing unused obsolete
packages.

Users should take note of whatever gets removed in steps 3-7 (hopefully
not too much) that is still available in Etch, and reinstall it at the end.

Hope this is useful information to someone.
regards,

-- 
Kevin B. McCarty <kmccarty@princeton.edu>   Physics Department
WWW: http://www.princeton.edu/~kmccarty/    Princeton University
GPG: public key ID 4F83C751                 Princeton, NJ 08544

[signature.asc (application/pgp-signature, attachment)]

Reply sent to Steve Langasek <vorlon@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Osamu Aoki <osamu@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #70 received at 401317-done@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: 401317-done@bugs.debian.org
Subject: Re: Chapt 4. use of aptitude etc for upgrade
Date: Wed, 4 Apr 2007 05:57:46 -0700
Hi Osamu,

Thank you for all of your work to test upgrades from sarge to etch.  We
believe that the current version of the release notes documents a viable
upgrade path that addresses all of the upgrade issues reported here.

If you believe this is not the case, it would be helpful if you would open a
new bug report for clarity which lists just those problems that still apply,
since this bug log is now quite long and would surely be a distraction from
resolving your specific problem.

Thanks,
-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
vorlon@debian.org                                   http://www.debian.org/



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 17 Jun 2007 16:44:32 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 16:14:58 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.